// OrSpecificationSet.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;


/**
 * The container generated by an order and containing the spefications about
 * an or stepe in a process
 *
 * @author Pietro Terna
 */
public class OrSpecificationSet extends SwarmObjectImpl{

    /** number (i.e. that of the order which has generated this object */
    public int myOrderNumber;
    /** the position of this sequence in the recipe */
    public int pos;
    /** the specification */
    public int nodeNumber;
    /** the vector of node positions in 'or' sequence (max 100) */
    public int[] nodePosition;


  /**
   * constructor for OrSpecificationSet
   */
  public OrSpecificationSet (Zone aZone, int n, int p) {

     // Call the constructor for the parent class
     super(aZone);

     nodePosition = new int[100];
     myOrderNumber=n;
     pos=p;

     if(StartVEFrame.verbose)
	 System.out.println("Or spec. created " +
			    "(by order " + myOrderNumber + " at pos. " + 
			    pos + "; NB first pos. is 0)");
  }

    /** setting the number if nodes */
    public void setNodeNumber(int k)
    {
	int i;
	nodeNumber = k;

	if(StartVEFrame.verbose)
	    {
		System.out.print("In orSpecificationSet of order # "+
				 myOrderNumber+
				 ", number of # "+nodeNumber+
				 "; node posistions:");
		for (i=1;i<=nodeNumber+1;i++)
		    System.out.print(" "+getNodePosition(i));
		System.out.println(" ");
	    }

    }

    /** setting the node position */
    public void setNodePosition(int node, int position){

	if(node>100){
	    System.out.println("More than 100 nodes in an 'or' sequence in "+
			       "orden # "+myOrderNumber);
	    MyExit.exit(1);
	}
	nodePosition[node-1]=position;
    }

    /** getting the node position; position of node # 1 is in 
     *  nodePosition[0] etc.
     */
    public int getNodePosition(int node){
	return nodePosition[node-1];
    }


    /**
     * returning the number of the order of this procurement specification
     */
    public int getNumber () {
	return myOrderNumber;
   }

    /**
     * returning the position of this procurement specification into its recipe
     */
    public int getPositionInRecipe() {
	return pos;
   }

    /**
     * returning the number of nodes (branches) in this 'or' sequence
     */
    public int getNodeNumber() {
	return nodeNumber;
   }

}
